
class Producer extends Thread {
  ChannelOfInt out ;

  public Producer (ChannelOfInt out) {
    this.out = out ;
  }

  public void run() {
    while(true)
      out.send(1) ;
  }
}

class Consumer extends Thread {
  ChannelOfInt in ;

  public Consumer (ChannelOfInt in) {
    this.in = in ;
  }

  public void run() {
    while(true) {
      int result = in.recv() ;
      System.out.println("" + result) ;
    }
  }
}

class Accum extends Thread {
  ChannelOfInt in, out ;
  int total ;

  public Accum (ChannelOfInt in, ChannelOfInt out) {
    this.in  = in ;
    this.out = out ;

    total = 0 ;
  }

  public void run() {
    while(true) {
      total += in.recv() ;
      out.send(total) ;
    }
  }
}

public class Eg2 {
  public static void main(String args[]) {
    ChannelOfInt c1 = new ChannelOfInt() ;
    ChannelOfInt c2 = new ChannelOfInt() ;

    Producer P = new Producer(c1) ;
    Accum    Q = new Accum(c1, c2) ;
    Consumer R = new Consumer(c2) ;

    P.start() ;
    Q.start() ;
    R.start() ;
  }
}


